%define daemon_user monitor
%define htmlroot /var/www/html
%define httpconfdir httpd/conf.d
%define daemon_group apache
%define http_binary httpd

Name: monitor-http-api
Version: %{op5version}
Release: %{op5release}%{?dist}
License: op5 Software License
Source: %name-%version.tar.gz
Vendor: op5 AB
BuildRoot: %{_tmppath}/%{name}-%{version}
Summary: OP5 Monitor API
Group: Applications/System
Prefix: /opt/monitor/op5/api
URL: https://kb.op5.com/display/DOC/HTTP-API

BuildRequires: doxygen
BuildRequires: make
BuildRequires: php-op5lib
BuildRequires: monitor-merlin
BuildRequires: monitor-nacoma

Requires: php-op5lib
Requires: monitor-livestatus
Requires: monitor-ninja
Requires: monitor-nacoma
Requires: monitor-pnp
Requires: monitor-command
Requires: op5license

%if 0%{?rhel} <= 6
BuildRequires: php-less
BuildRequires: php >= 5.3
Requires: php-xml
Requires: php-mbstring
Requires: php >= 5.3
%else
BuildRequires: php-lessphp
%endif


%description
HTTP API for op5 Monitor.


%package test
Summary: Test scripts for monitor HTTP API
Group: Applications/System

Requires: phantomjs
Requires: monitor-http-api = %{version}
Requires: op5-mysql
Requires: op5-phpunit
Requires: python-nose
Requires: python-PyYAML
# Because we want to parse HTML
Requires: python-beautifulsoup4
# Better etree than the built in
Requires: python-lxml
# Because I want https...
Requires: portal
# Because we go too near PNP configuration
Requires: monitor-pnp
# Because we want to import logs
Requires: monitor-merlin
Requires: op5license-generator
Requires: op5license-tests
Requires: php-mbstring
%if 0%{?rhel} <= 6
Requires: ruby20
Requires: ruby20-devel
%else
Requires: ruby
Requires: ruby-devel
%endif

%description test
Test scripts for HTTP API


%prep
%setup -q


%build
make
make docs


%install
rm -rf %buildroot
mkdir -p %buildroot%prefix
cp -r api/* %buildroot%prefix
mkdir -p %buildroot/opt/monitor/op5/nacoma/api
mkdir -p %buildroot/opt/monitor/op5/nacoma/classes
cp nacoma/api/http.php %buildroot/opt/monitor/op5/nacoma/api
cp nacoma/classes/http_api_class.php %buildroot/opt/monitor/op5/nacoma/classes
cp op5build/upgrade_config.php %buildroot%prefix
cp Makefile %buildroot%prefix
cp -r test %buildroot%prefix/..
mkdir -p  %buildroot/etc/%httpconfdir
%if 0%{?rhel} <= 6
cp include/monitor-http_api.conf %buildroot/etc/%httpconfdir/monitor-api.conf
%else
cp include/monitor-http_api.conf.el7 %buildroot/etc/%httpconfdir/monitor-api.conf
%endif
mkdir -p %buildroot/opt/plugins
install include/check_unexported_config.php %buildroot/opt/plugins/check_unexported_config.php

mkdir -p %buildroot/etc/op5
cp include/http_api.yml %buildroot/etc/op5

mkdir -p %buildroot/opt/monitor/etc/oconf
cp test/config/* %buildroot/opt/monitor/etc/oconf


%post
%if 0%{?rhel} <= 6
test -f /etc/init.d/%http_binary && /etc/init.d/%http_binary restart || :
%else
test -f /etc/init.d/%http_binary && /etc/init.d/%http_binary restart || :
if ! systemctl is-enabled httpd > /dev/null 2>&1 ; then
	systemctl restart %http_binary
fi
%endif

# Cleanup symlinks we don't use anymore
if [ -f %htmlroot/api ]; then
	rm -rf %htmlroot/api
fi

# Upgrade the config file, without sed, mind you
php %prefix/upgrade_config.php /etc/op5/http_api.yml


%postun
rm -f %prefix/.htaccess
rm -f %prefix/api.ini


%files
%defattr(-,monitor,%daemon_group)
%prefix
/etc/%httpconfdir/monitor-api.conf
/opt/monitor/op5/nacoma/api/http.php
/opt/monitor/op5/nacoma/classes/http_api_class.php
%config(noreplace) /etc/op5/http_api.yml
%attr(755, root, root) /opt/plugins/check_unexported_config.php
%exclude %prefix/Makefile
%exclude %prefix/../test


%files test
%defattr(664,monitor,%daemon_group,755)
%prefix/Makefile
%prefix/../test
/opt/monitor/etc/oconf/*


%clean
rm -rf %buildroot


%changelog
* Fri Feb 10 2017 Robin Engstrom <robin.engstrom@op5.com> 0.00-1
– Standard Packaging
